/* File: fft-main.c
 *
 * Main file for calling the UNSPECIALIZED FFT algorithm
 */

#include <math.h>
#include <stdlib.h>
#include "fft.h"

void generate_data(int q);

int main(int argc, char* argv[]) {
  int q;

  if (argc != 2) {
    printf("Usage: %s <q>\n", argv[0]);
    printf("q  quotient\n\n");
    printf("  An array of size %d is filled with function values sin(x/q), for x=0,...,%d\n", N, N-1);
    return -1;
  } else {
    q    = atoi(argv[1]);
    generate_data(q);
    printf("sum of resulting array = %g\n", applyfft());
    return 0;
  }
}
